<?
/*--------------------------------------------------------------------
   KorWeblog :: Highly Customizable Weblog/CMS
   Copyright (C) 2001,2002 by Im Eunjea <eunjea@kldp.org>
   For detail of license and/or other info, see the file doc/COPYING.
   http://weblog.kldp.org
----------------------------------------------------------------------

LICENSE

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software 
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
----------------------------------------------------------------------*/

if (!defined("LOAD_MODULE"))
   die ("You can not access this file directly...");

$logfile = "$CONF[G_PATH]/logs/access_log";
$timezone =  "+0900";
$lookup_size = 0;

new apache_log($logfile,$timezone,$lookup_size);

class apache_log {

   function apache_log($logfile,$timezone,$lookup_size) {
      $remote_host = $this->get_var("REMOTE_ADDR", "-");
      $remote_user = $this->get_var("REMOTE_USER", "-"); 
      $remote_ident = $this->get_var("REMOTE_IDENT", "-"); 
      $server_port = $this->get_var("SERVER_PORT", 80);
      $refer = $this->get_var("HTTP_REFERER", "-");

      if($server_port!=80) $server_port = ":" . $server_port;
      else $server_port = "";

      $server_name = $this->get_var("SERVER_NAME",  "-");
      $request_method = $this->get_var("REQUEST_METHOD",  "GET");
      $request_uri = $this->get_var("REQUEST_URI",  "");
      $user_agent = $this->get_var("HTTP_USER_AGENT",  "");

      if($lookup_size && KWL_GetConf("G_PATH")) {
         $filename = ereg_replace( "\?.*",  "", $request_uri);
         $filename =  KWL_GetConf("G_PATH") . $filename;
         if(!$size = filesize($filename)) $size = 0;
      } else $size = 0;

      $date = date("d/M/Y:H:i:s", time());
      $log = "$remote_host $remote_ident $remote_user [$date $timezone] \"".
             "$request_method http://$server_name$server_port$request_uri\"".
             " 200 $size \"$refer\" \"$user_agent\"\n";

      $this->log_write($log,$logfile);
   }

   function log_write($str,$logfile) {
      if($fd = @fopen($logfile,"a")) {
         fputs($fd, $str);
         fclose($fd);
      }
   }

   function get_var($name,$default) {
      $var = $_SERVER[$name];
      return $var ? $var : $default;
   }
}
?>
